/* Copyright 2019 Ling Zhang

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License. */

import{ClassInitializer as e,singleton as t}from"@agentframework/domain";import{WebRequest as i,method as r,Secret as o,ParameterError as n,AuthenticationError as s,controller as a,StreamToBuffer as d,WebRequestIdentity as l,WebApplicationIdentity as p,HttpError as c,MakeCookieHeaders as u,MaliciousRequestError as g,ApplicationError as y,FileField as h,TextField as m,WebForm as f,WebApplication as v,WebApplicationSettings as S,NotFoundError as I}from"@agentframework/web";import{URL as _,resolve as E}from"url";import{Resolvable as w,CreateHashedObjectId as b,ObjectId as O,Exception as C,Base62 as N,IsExpiredObjectId as U,CreateObjectId as L,Base58 as R}from"@agentframework/app";import{property as x,model as T,Model as P,RecordCollection as k,key as A,BlobCollection as D}from"@agentframework/data";import{stringify as F,parse as B}from"querystring";import G,{Headers as M}from"node-fetch";import{Root as W}from"protobufjs";import{intersection as j}from"lodash";import{join as H,normalize as q,resolve as $,sep as z,isAbsolute as K,parse as J,extname as X,basename as Y}from"path";import{createHash as V}from"crypto";import{isIP as Q}from"net";import{Readable as Z}from"stream";import{statSync as ee,createReadStream as te}from"fs";function ie(e,t,i,r){var o,n=arguments.length,s=n<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,i):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,i,r);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(s=(n<3?o(s):n>3?o(t,i,s):o(t,i))||s);return n>3&&s&&Object.defineProperty(t,i,s),s}function re(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}class WebFoundationController extends w{getFailureURL(e,t){return e.logger.error(t),"/#"+e.settings.WEB_SIGNIN_FAILED_PATH}}class WebFoundationService extends w{}let oe=class ExternalUserModel extends P{};ie([x(),re("design:type",Object)],oe.prototype,"uid",void 0),ie([x(),re("design:type",String)],oe.prototype,"provider",void 0),ie([x(),re("design:type",String)],oe.prototype,"providerProtocol",void 0),ie([x(),re("design:type",String)],oe.prototype,"providerURL",void 0),ie([x(),re("design:type",String)],oe.prototype,"providerId",void 0),ie([x(),re("design:type",String)],oe.prototype,"providerData",void 0),ie([x(),re("design:type",String)],oe.prototype,"userData",void 0),ie([x(),re("design:type",String)],oe.prototype,"user",void 0),ie([x(),re("design:type",String)],oe.prototype,"username",void 0),ie([x(),re("design:type",String)],oe.prototype,"domain",void 0),ie([x(),re("design:type",Object)],oe.prototype,"email",void 0),ie([x(),re("design:type",Boolean)],oe.prototype,"emailCertified",void 0),ie([x(),re("design:type",Object)],oe.prototype,"mobile",void 0),ie([x(),re("design:type",Boolean)],oe.prototype,"mobileCertified",void 0),ie([x(),re("design:type",String)],oe.prototype,"displayName",void 0),ie([x(),re("design:type",String)],oe.prototype,"displayImageURL",void 0),ie([x(),re("design:type",String)],oe.prototype,"displayImageFile",void 0),ie([x(),re("design:type",Object)],oe.prototype,"familyName",void 0),ie([x(),re("design:type",Object)],oe.prototype,"givenName",void 0),ie([x(),re("design:type",Object)],oe.prototype,"gender",void 0),ie([x(),re("design:type",Object)],oe.prototype,"dob",void 0),ie([x(),re("design:type",Object)],oe.prototype,"status",void 0),ie([x(),re("design:type",Object)],oe.prototype,"bio",void 0),ie([x(),re("design:type",Object)],oe.prototype,"homepage",void 0),ie([x(),re("design:type",Object)],oe.prototype,"locale",void 0),oe=ie([T("external_user")],oe);class ExternalUserCollection extends k{constructor(){super(oe)}}class ExternalUserService extends WebFoundationService{async findOrCreateExternalUser(e,t){const i=await e.resolve(ExternalUserCollection),r=b([t.uid,t.providerId]);let o=await i.get(r);return o||(o=new oe,Object.assign(o,t),i.add(r,o).then(e=>{if(!e)throw new Error("Unable to create external user");return e}))}async findOrCreateOrUpdateDifferenceExternalUser(e,t){const i=await e.resolve(ExternalUserCollection),r=b([t.uid,t.providerId]);let o=await i.get(r),n=!1;if(o){for(const e of Object.keys(t))if(o[e]!=t[e]&&"object"!=typeof t[e]){n=!0;break}if(!n)return o}const s=o||new oe;return Object.assign(s,t),n?i.merge(r,s).then(e=>{if(!e)throw new Error("Unable to merge external user");return s}):i.add(r,s).then(e=>{if(!e)throw new Error("Unable to create external user");return e})}}let ne=class UserModel extends P{};ie([A(),re("design:type",Number)],ne.prototype,"id",void 0),ie([A(),re("design:type",String)],ne.prototype,"name",void 0),ie([x(),re("design:type",String)],ne.prototype,"displayName",void 0),ie([x(),re("design:type",String)],ne.prototype,"displayImageURL",void 0),ie([x(),re("design:type",String)],ne.prototype,"displayImageFile",void 0),ie([x(),re("design:type",Object)],ne.prototype,"signature",void 0),ie([x(),re("design:type",String)],ne.prototype,"email",void 0),ie([x(),re("design:type",String)],ne.prototype,"mobile",void 0),ie([x(),re("design:type",Array)],ne.prototype,"roles",void 0),ie([x(),re("design:type",Object)],ne.prototype,"identities",void 0),ie([x(),re("design:type",Object)],ne.prototype,"settings",void 0),ie([x(),re("design:type",String)],ne.prototype,"theme",void 0),ie([x(),re("design:type",String)],ne.prototype,"timezone",void 0),ie([x(),re("design:type",String)],ne.prototype,"locale",void 0),ie([x(),re("design:type",String)],ne.prototype,"password",void 0),ie([x(),re("design:type",String)],ne.prototype,"passwordSalt",void 0),ie([x(),re("design:type",String)],ne.prototype,"paymentPassword",void 0),ie([x(),re("design:type",String)],ne.prototype,"paymentPasswordSalt",void 0),ne=ie([T("user")],ne);class UserCollection extends k{constructor(){super(ne)}}let se=class EmailModel extends P{};ie([A(),re("design:type",String)],se.prototype,"name",void 0),ie([x(),re("design:type",String)],se.prototype,"displayName",void 0),ie([x(),re("design:type",String)],se.prototype,"user",void 0),ie([x(),re("design:type",Boolean)],se.prototype,"verified",void 0),ie([x(),re("design:type",Date)],se.prototype,"verifiedAt",void 0),ie([x(),re("design:type",Object)],se.prototype,"verifiedBy",void 0),ie([x(),re("design:type",String)],se.prototype,"verifiedFrom",void 0),ie([x(),re("design:type",String)],se.prototype,"verifiedReason",void 0),ie([x(),re("design:type",String)],se.prototype,"verifyToken",void 0),ie([x(),re("design:type",Number)],se.prototype,"verifyTokenFailures",void 0),ie([x(),re("design:type",Date)],se.prototype,"verifyTokenExpires",void 0),ie([x(),re("design:type",Date)],se.prototype,"resetPasswordAt",void 0),ie([x(),re("design:type",String)],se.prototype,"resetPasswordFrom",void 0),ie([x(),re("design:type",Object)],se.prototype,"resetPasswordBy",void 0),ie([x(),re("design:type",String)],se.prototype,"resetPasswordToken",void 0),ie([x(),re("design:type",Number)],se.prototype,"resetPasswordTokenFailures",void 0),ie([x(),re("design:type",Date)],se.prototype,"resetPasswordTokenExpires",void 0),se=ie([T("email")],se);class EmailCollection extends k{constructor(){super(se)}}class UserService extends WebFoundationService{async findOneById(e,t){return(await e.resolve(UserCollection)).get(t)}async isEmailBeenUsed(e,t){const i=await e.resolve(EmailCollection),r=b(t.trim().toLowerCase());return i.get(r).then(e=>!!e)}async isMobileExists(e,t){return!1}async findUserFromEmail(e,t){const i=await e.resolve(EmailCollection),r=b(t.trim().toLowerCase()),o=await i.get(r);if(o&&o.user)return(await e.resolve(UserCollection)).get(new O(o.user))}async findOrCreateUserFromExternalUser(e,t){const i=await e.resolve(UserCollection),r=await e.resolve(EmailCollection),o=t._id,n=await i.get(o);if(n)return n;if(t.user){const e=await i.get(t.user);if(e)return e}const s={displayName:t.displayName,displayImageURL:t.displayImageURL||"",displayImageFile:t.displayImageFile||"",roles:["user"]};if(t.email&&t.emailCertified){const i=e.settings.ADMIN_EMAIL;i&&"string"==typeof i&&t.email===i&&s.roles.push("admin")}t.locale&&(s.locale=t.locale);const a=await i.add(o,s);if(!a)throw new Error("Unable to create external user");if(t.email&&t.emailCertified){const i=b(t.email.trim().toLowerCase()),o=new se;o.name=t.email,o.displayName=t.displayName,o.user=a._id.toHexString(),await r.add(i,o)||e.logger.warn({user:a._id,email:o.name})}return a}}const ae=/^https?:\/\//i;function de(e){return null!=e&&ae.test(e)}class ExternalFetcher{constructor(e={}){if(this.defaults=e,e.baseURL&&!de(e.baseURL))throw new C({baseURL:e.baseURL},"Invalid fetch base url")}makeFetchOptions(e={}){const t=Object.assign({},this.defaults.query,e.query||{}),i=Object.assign({},this.defaults.headers,e.headers||{}),r=Object.assign({},e),o=r.headers=new M(i);let n;if(r.url&&de(r.url))n=new _(r.url);else{if(!this.defaults.baseURL)throw new C({url:r.url},"Invalid fetch url");n=new _(this.defaults.baseURL+r.url)}for(const e of Object.keys(t))n.searchParams.append(e,t[e]);if(r.data){const e=o.get("Content-Type");e&&e.toString().toLowerCase().startsWith("application/json")?r.body=JSON.stringify(r.data):e&&e.toString().toLowerCase().startsWith("application/x-www-form-urlencoded")?r.body=F(r.data):r.body=r.data,"string"==typeof r.body&&o.append("Content-Length",String(r.body.length))}return delete r.url,delete r.query,delete r.data,{url:n.toString(),init:r}}httpRequest(e){const{url:t,init:i}=this.makeFetchOptions(e);return G(t,i).then(async e=>{const t={url:e.url,status:e.status,statusText:e.statusText,headers:e.headers,type:e.headers.get("content-type")||"text/html"};return t.type.startsWith("application/json")?t.data=await e.json():t.type.startsWith("text/")?t.text=await e.text():t.body=e,t})}httpPost(e,t,i={}){return i.method="POST",i.url=e,i.data=t,this.httpRequest(i)}httpPut(e,t,i={}){return i.method="PUT",i.url=e,i.data=t,this.httpRequest(i)}httpGet(e,t={}){return t.method="GET",t.url=e,this.httpRequest(t)}httpGetAsText(e,t={}){return this.httpGet(e,t).then(e=>{if(!e.text)throw new Error("ResponseIsNotText");return e.text})}httpGetAsBuffer(e,t={}){return this.httpGet(e,t).then(e=>{if(!e.body)throw new Error("ResponseIsNotBuffer");return e.body.buffer()})}httpGetAsJson(e,t={}){return this.httpGet(e,t).then(e=>{if(!e.data)throw new Error("ResponseIsNotJSON");return e.data})}httpDelete(e,t={}){return t.method="DELETE",t.url=e,this.httpRequest(t)}}class OAuth2Client extends ExternalFetcher{constructor(e){super({headers:{Accept:"application/json","Content-Type":"application/json"}}),this.options=e}authorizeURL(e){const t={client_id:this.options.client_id,response_type:"code"};Array.isArray(e.scope)&&(e.scope=e.scope.join(" "));const i=Object.assign({},t,e);return`${this.options.authorization_endpoint}?${F(i)}`}getToken(e){Array.isArray(e.scope)&&(e.scope=e.scope.join(" "));const t=Object.assign({},e,{client_id:this.options.client_id,client_secret:this.options.client_secret,grant_type:"authorization_code"});return super.httpPost(this.options.token_endpoint,t,{headers:{"Content-Type":"application/x-www-form-urlencoded"}}).then(e=>{if(!e.data)throw new Error("InvalidOAuthTokenResponseType");return e.data}).catch(e=>(console.log("errror get token",e),console.log("try get token using json payload",t),super.httpPost(this.options.token_endpoint,t)))}get(e){return super.httpGetAsJson(e)}}class OpenIdAuthenticator extends WebFoundationService{update(e){this.idProvider=e.provider,this.oauth=new OAuth2Client({client_id:e.appID,client_secret:e.appSecret,authorization_endpoint:e.authorization_endpoint,token_endpoint:e.token_endpoint}),e.scope?this.scope=e.scope:this.scope="openid"}getAuthorizeURL(e,t){return this.oauth.authorizeURL({redirect_uri:e,scope:this.scope,state:String(t)})}getSuccessURL(e){return"/#"+this.settings.WEB_SIGNIN_SUCCESS_PATH}getFailureURL(e){return"/#"+this.settings.WEB_SIGNIN_FAILED_PATH}getToken(e,t){return this.oauth.getToken({redirect_uri:e,code:t,scope:this.scope}).then(e=>{try{if(e.id_token){const t=e.id_token.split("."),i=Buffer.from(t[1],"base64");e.id_token=JSON.parse(i.toString())}else e.id_token={},e.id_token_error="id_token is not found"}catch(t){e.id_token_error=t.message}return e})}async refreshToken(e){throw new Error("Not implemented refresh token")}async getProfile(e){const t=e.id_token;let i=[],r=null,o=null,n=null,s=!1;if(t.email&&(r=t.email,s=t.email_verified),r){const e=r.split("@");o=e[0],n=e[1]}return r&&s&&i.push({type:"email",value:r}),{uid:t.sub,providerData:null,identities:i,username:o,domain:n,email:r,emailCertified:s,mobile:null,mobileCertified:!1,displayName:t.name,displayImageURL:t.picture,familyName:t.family_name,givenName:t.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:t.locale}}}class CurrentUser extends ne{static async[e](e){if(!(e instanceof i))throw new Error("CurrentUser is only resolvable from ctx scope");const t=e.identity.user;if(t&&O.isValid(t))return e.resolve(UserService).then(i=>i.findOneById(e,t).then(e=>{if(!e)throw new Error("NoCurrentUser");return Reflect.setPrototypeOf(e,CurrentUser.prototype),e}));throw new Error("NoCurrentUser")}}var le,pe,ce;class OpenIdController extends WebFoundationController{async getAuthenticator(e){const t=e.construct(OpenIdAuthenticator,[],!0),i=await this.discover(e);return t.update({provider:i,issuer:i.providerURL,appID:i.appID,appSecret:i.appSecret,token_endpoint:i.providerConfiguration.token_endpoint,authorization_endpoint:i.providerConfiguration.authorization_endpoint,scope:i.scope}),t}OnProfile(e,t,i){return Promise.resolve(null)}async[le=Symbol("start")](e){let t;try{const i=await this.getAuthenticator(e),r=E(e.publicUrl,"callback");t=i.getAuthorizeURL(r,Date.now())}catch(i){t=await this.getFailureURL(e,new C(i,"Unable to start authentication"))}e.redirect(t)}async[pe=Symbol("callback")](e){const t=await this.getAuthenticator(e),i=t.idProvider,r=E(e.publicUrl,"callback"),o=Number(e.query.state);if(o>Date.now()||o<Date.now()-e.settings.OIDC_AUTHENTICATION_EXPIRES_IN_MILLISECONDS)e.redirect(t.getFailureURL(new Error("Invalid Authentication State")));else{if(e.query.error){const i=new Error(`${e.query.error}: ${e.query.error_description}`);return e.logger.error(i,"Authentication Error"),void e.redirect(t.getFailureURL(i))}try{const o=e.query.code,n=await t.getToken(r,o);let s=await this.OnProfile(e,n,i).catch(()=>null);if(s||(s=await t.getProfile(n).catch(()=>null)),!s||!s.uid){let i=new Error("Unable to get unique user identity from provider");return e.logger.error(i),void e.redirect(t.getFailureURL(i))}s&&(Reflect.has(s,"user")&&(s.user&&O.isValid(s.user)?e.logger.warn(`External user ${s.uid}@${i._id} already set the user field to ${s.user}`):delete s.user),s.displayImageURL||e.logger.warn(`External user ${s.uid}@${i._id} do not have a profile image`),s.provider=i.provider,s.providerProtocol=i.providerProtocol,s.providerURL=i.providerURL,s.providerId=i._id.toString());const a=await this.ExternalUsers.findOrCreateOrUpdateDifferenceExternalUser(e,s);let d;a.user?(console.log("lookup",a.user),d=await this.Users.findOneById(e,a.user)):d=a.email&&a.emailCertified?await this.Users.findUserFromEmail(e,a.email):void 0;const l=await e.resolve(CurrentUser).catch(()=>void 0),p=await this.OnAuthenticated(e,i,n,a,d,l);e.redirect(t.getSuccessURL(p))}catch(i){e.logger.error(i,"Authentication Callback Error"),e.redirect(t.getFailureURL(i))}}}}ie([t(),re("design:type",ExternalUserService)],OpenIdController.prototype,"ExternalUsers",void 0),ie([t(),re("design:type",UserService)],OpenIdController.prototype,"Users",void 0),ie([r("GET","/start"),re("design:type",Function),re("design:paramtypes",[Object]),re("design:returntype",Promise)],OpenIdController.prototype,le,null),ie([r("GET","/callback"),re("design:type",Function),re("design:paramtypes",[Object]),re("design:returntype",Promise)],OpenIdController.prototype,pe,null);class SHA512{static sign(e,t){const i=new o(e.settings.SECRET_KEYS,"sha512").sign(t);return N.fromBuffer(t)+"."+N.fromBuffer(i)}static verify(e,t){const i=t.indexOf(".");if(i>0&&i<t.length){const i=new o(e.settings.SECRET_KEYS,"sha512");try{const e=t.split("."),r=N.toBuffer(e[0]),o=N.toBuffer(e[1]);return!!i.verify(r,o)&&r}catch(e){return!1}}return!1}}class SessionCookieHelper{static get(e){const t=e.cookies.get(e.settings.WEB_SESSION_COOKIE_KEY);if(t&&t.length>40){const i=SHA512.verify(e,t);if(i)return i;e.logger.warn({id:e.ip,cookie:t},"[INTRUSION DETECTED] User sent invalidate auth token:")}return null}static set(e,t){const i={path:"/api",httpOnly:!0,secure:!e.settings.DEBUG};e.res.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,SHA512.sign(e,t),i)}static clear(e){const t={path:"/api",httpOnly:!0,maxAge:1,expires:new Date(2013,1,1),secure:!e.settings.DEBUG};e.res.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,"",t)}}class SessionProtocol{static get schema(){const e=W.fromJSON({nested:{IdentityProfile:{fields:{_id:{type:"bytes",id:1},id:{type:"string",id:2},displayName:{type:"string",id:3},displayImageURL:{type:"string",id:4}}},WebSession:{fields:{session:{type:"string",id:1},user:{type:"string",id:2},token:{type:"string",id:3},roles:{type:"string",rule:"repeated",id:4},groups:{type:"string",rule:"repeated",id:5},scope:{type:"string",rule:"repeated",id:6},profile:{type:"IdentityProfile",id:7},timezone:{type:"string",id:8},locale:{type:"string",id:9},theme:{type:"string",id:10}}}}}).lookupType("WebSession");return Reflect.defineProperty(this,"schema",{value:e}),e}static encode(e){const t=Object.assign({},e);if(e.profile){const i=e.profile;t.profile={_id:i._id.id,id:i.id,displayName:i.displayName,displayImageURL:i.displayImageURL}}return this.schema.encode(t).finish()}static decode(e,t={}){let i;try{i=this.schema.decode(e)}catch(e){return null}for(const e of this.SessionFields)t[e]=i[e];if(i.profile){const e={};Object.assign(e,{_id:i.profile._id&&i.profile._id.byteLength?new O(i.profile._id):void 0,id:i.profile.id||void 0,displayName:i.profile.displayName,displayImageURL:i.profile.displayImageURL}),t.profile=e}return t}}SessionProtocol.SessionFields=["session","user","token","roles","groups","scope","profile","theme","timezone","locale"];class SessionHelper{static load(e,t){const i=SessionCookieHelper.get(e);i&&i.length&&SessionProtocol.decode(i,t)}static save(e,t){if(!t||!Object.keys(t).length)throw new n("Unable to update empty identity, please use WebIdentityService.clear() instead");const i=SessionProtocol.encode(t);if(!i||!i.byteLength)throw new s("Invalid session data (byteLength=0)");SessionCookieHelper.set(e,i)}static clear(e){SessionCookieHelper.clear(e)}}class SessionService extends WebFoundationService{async CreateSession(e,t){if(e.identity.session)throw new Error("SessionAlreadyExists");const i=SessionService.CreateNewSessionId(e),r=SessionService.CreateNewTokenId(e),o=Object.assign({},t,{session:i,token:r});return SessionHelper.save(e,o),Promise.resolve(o)}async ValidateSession(e){return!!(e.identity&&e.identity.token&&O.isValid(e.identity.token))&&!U(new O(e.identity.token))}async UpdateSession(e,t,i){return e.identity.session===t&&(SessionHelper.save(e,Object.assign({},e.identity,i,{session:e.identity.session,token:SessionService.CreateNewTokenId(e)})),!0)}async ExtendSession(e,t){return this.UpdateSession(e,t,{})}async TerminateSession(e,t,i){if(e.identity.session===t){SessionHelper.clear(e);for(const t of Object.keys(e.identity))"id"!==t&&"address"!==t&&delete e.identity[t];return!0}return!1}static CreateNewSessionId(e){return(new O).toHexString()}static CreateNewTokenId(e){const t=new Date(Date.now()+e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS);return new O(t).toHexString()}}class AuthenticationService extends WebFoundationService{async IsAuthenticated(e){const t=await this.Sessions.ValidateSession(e);if(t&&e.identity.session&&e.identity.token){new O(e.identity.token).getTimestamp().getTime()-Date.now()<e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS-e.settings.WEB_TOKEN_EXPIRES_IN_MILLISECONDS&&await this.Refresh(e)}return t}async SignIn(e,t,i=["user","admin"]){const r=e.identity;if(e.state.new_device_id)throw new Error("Unable to authenticate without cookie support");return r.session&&!U(new O(r.token))&&(e.logger.debug({session:r.session},"Automatically logged out previous session for new user login"),await this.Sessions.TerminateSession(e,r.session,"SignIn")),this.Sessions.CreateSession(e,{user:t._id.toString(),roles:j(t.roles,i),profile:{_id:t._id,id:t.id,displayName:t.displayName,displayImageURL:t.displayImageURL}})}async Update(e,t){const i=t._id.toHexString();if(e.identity.user!==i)throw new Error("Unable to update signed in user to another user");return this.Sessions.UpdateSession(e,i,{user:t._id.toHexString(),profile:{_id:t._id,id:t.id,displayName:t.displayName,displayImageURL:t.displayImageURL}}).then(()=>!0).catch(()=>!1)}async Refresh(e){return!!e.identity.session&&this.Sessions.ExtendSession(e,e.identity.session).then(()=>!0).catch(()=>!1)}async SignOut(e,t="SignOut"){return!!e.identity.session&&this.Sessions.TerminateSession(e,e.identity.session,t)}}ie([t(),re("design:type",SessionService)],AuthenticationService.prototype,"Sessions",void 0),function(e){e.SIGN_UP="sign-up",e.SIGN_UP_FAILED="sign-up-failed",e.SIGN_IN="sign-in",e.SIGN_IN_FAILED="sign-in-failed",e.SIGN_OUT="sign-out",e.SESSION_EXPIRED="session-expired",e.ACCESS_DENIED="access-denied"}(ce||(ce={}));let ue=class EventModel extends P{};ie([x(),re("design:type",String)],ue.prototype,"type",void 0),ie([x(),re("design:type",Object)],ue.prototype,"context",void 0),ue=ie([T("event")],ue);class EventCollection extends k{constructor(){super(ue)}}class OpenIdAuthController extends OpenIdController{async OnAuthenticated(e,t,i,r,o,n){if(o){const i=await this.WebAuth.SignIn(e.req,o);return i&&(e.logger.debug({user:o._id,email:r.email,roles:o.roles.join(","),session:i.session},`Logged in with ${t.displayName}`),await this.Events.createSignInEvent(e,t,o)),o}if(r.email){if(await this.Users.isEmailBeenUsed(e,r.email))throw new s(`Email ${r.email} is already been used`)}const a=await this.Users.findOrCreateUserFromExternalUser(e,r);if(!a)throw new s({provider:t.provider,providerProtocol:t.providerProtocol,providerId:t._id},`Failed to register user ${r.uid}`);return this.WebAuth.SignIn(e.req,a).then(i=>i?(e.logger.debug({user:a._id,email:r.email,roles:a.roles.join(","),session:i.session},`First time logged in with ${t.displayName}`),this.Events.createSignUpEvent(e,t,a).then(()=>a)):a)}}ie([t(),re("design:type",class EventService extends WebFoundationService{async getLatestEvents(e){return[]}async createSignInEvent(e,t,i){const r=ce.SIGN_IN,o={provider:t.displayName,providerId:t._id,user:{_id:i._id,displayName:i.displayName,displayImageURL:i.displayImageURL}},n=await e.resolve(EventCollection),s=new ue;return s.type=r,s.context=o,n.add(L(),s)}async createSignUpEvent(e,t,i){const r=ce.SIGN_UP,o={provider:t.displayName,providerId:t._id,user:{_id:i._id,displayName:i.displayName,displayImageURL:i.displayImageURL}},n=await e.resolve(EventCollection),s=new ue;return s.type=r,s.context=o,n.add(L(),s)}async createSignOutEvent(e,t){const i=ce.SIGN_OUT,r={provider:t.displayName,providerId:t._id},o=await e.resolve(EventCollection),n=new ue;return n.type=i,n.context=r,o.add(L(),n)}})],OpenIdAuthController.prototype,"Events",void 0),ie([t(),re("design:type",AuthenticationService)],OpenIdAuthController.prototype,"WebAuth",void 0);class OpenIdConnect extends ExternalFetcher{constructor(){super(...arguments),this.ConfigurationEndpoint="/.well-known/openid-configuration"}discovery(e){e.pathname=H(e.pathname,this.ConfigurationEndpoint);const t=e.toString();return super.httpGetAsJson(t)}static[e](e,t){return new OpenIdConnect}}let ge=class ExternalProviderModel extends P{static toJSON(e){return{provider:e.provider,providerProtocol:e.providerProtocol,providerURL:e.providerURL,providerFingerprint:e.providerFingerprint,providerConfiguration:JSON.stringify(e.providerConfiguration),appID:e.appID,appSecret:e.appSecret,scope:e.scope,displayName:e.displayName,displayImageURL:e.displayImageURL,description:e.description,createdAt:e.createdAt,createdFrom:e.createdFrom,createdBy:e.createdBy?JSON.stringify(e.createdBy):"{}",expireAt:e.expireAt,updatedAt:e.updatedAt,updatedFrom:e.updatedFrom,updatedBy:e.updatedBy?JSON.stringify(e.updatedBy):"{}"}}fromJSON(e){this.provider=e.provider,this.providerProtocol=e.providerProtocol,this.providerURL=e.providerURL,this.providerFingerprint=e.providerFingerprint,this.providerConfiguration=e.providerConfiguration?JSON.parse(e.providerConfiguration):{},this.appID=e.appID,this.appSecret=e.appSecret,this.scope=e.scope,this.displayName=e.displayName,this.displayImageURL=e.displayImageURL,this.description=e.description,this.createdAt=e.createdAt,this.createdFrom=e.createdFrom,this.createdBy=e.createdBy?JSON.parse(e.createdBy):{},this.expireAt=e.expireAt,this.updatedAt=e.updatedAt,this.updatedFrom=e.updatedFrom,this.updatedBy=e.updatedBy?JSON.parse(e.updatedBy):{}}};ie([x(),re("design:type",String)],ge.prototype,"provider",void 0),ie([x(),re("design:type",String)],ge.prototype,"providerProtocol",void 0),ie([x(),re("design:type",String)],ge.prototype,"providerURL",void 0),ie([x(),re("design:type",String)],ge.prototype,"providerFingerprint",void 0),ie([x(),re("design:type",Object)],ge.prototype,"providerConfiguration",void 0),ie([x(),re("design:type",String)],ge.prototype,"appID",void 0),ie([x(),re("design:type",String)],ge.prototype,"appSecret",void 0),ie([x(),re("design:type",String)],ge.prototype,"scope",void 0),ie([x(),re("design:type",String)],ge.prototype,"displayName",void 0),ie([x(),re("design:type",String)],ge.prototype,"displayImageURL",void 0),ie([x(),re("design:type",String)],ge.prototype,"description",void 0),ge=ie([T("external_provider")],ge);class ExternalProviderCollection extends k{constructor(){super(ge)}}class ExternalProviderService extends WebFoundationService{async findOrResolveExternalProvider(e,t){const i=this.createProviderId(t),r=await e.resolve(ExternalProviderCollection),o=await r.get(i);if(o){if(o.providerConfiguration)return o;if(o.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL),!o.providerConfiguration)throw new Error("Unable to discover external id provider");return r.merge(i,o).then(e=>o)}if(t.providerConfiguration||(t.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL)),!t.providerConfiguration)throw new Error("Unable to discover external id provider");return r.add(i,t).then(e=>{if(!e)throw new Error("Unable to create external provider");return e})}createProviderId(e){const t=[String(e.provider),String(e.providerProtocol),String(e.providerURL)];return e.appID&&t.push(String(e.appID)),b(t)}async discoverProviderConfiguration(e,t){let i;try{i=new _(t)}catch(e){throw new C(e,"Invalid external provider: "+t)}return"https:"!==i.protocol&&e.logger.warn("Unsecured external id provider: "+t),e.construct(OpenIdConnect).discovery(i).catch(t=>(e.logger.warn(t,{issuer:i},"Unable to discover the configuration"),null))}}class BearerClient extends ExternalFetcher{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error("Access token can not be null or empty")}get(e){return super.httpGetAsJson(e)}}let ye=class GoogleOpenIdAuthController extends OpenIdAuthController{async discover(e){if(!e.settings.OIDC_GOOGLE)throw new Error("GoogleAuthIsNotEnabled");const t={provider:"google",providerProtocol:"openid",providerURL:e.settings.OIDC_GOOGLE_ISSUER_URL,displayName:"Google Account",displayImageURL:"https://www.google.com/favicon.ico"},i=await this.idp.findOrResolveExternalProvider(e,t);return i.appID=i.appID||e.settings.OIDC_GOOGLE_CLIENT_ID,i.appSecret=e.settings.OIDC_GOOGLE_CLIENT_SECRET,e.settings.OIDC_GOOGLE_SCOPES&&(i.scope=i.scope||e.settings.OIDC_GOOGLE_SCOPES.join(" ")),i}async OnProfile(e,t,i){return this.google.getProfile(e,t,i)}};ie([t(),re("design:type",ExternalProviderService)],ye.prototype,"idp",void 0),ie([t(),re("design:type",class GoogleProfileService{constructor(){this.TrustedEmailDomains=["gmail.com"]}async getProfile(e,t,i){const r=t.id_token;if(!i.providerConfiguration||!i.providerConfiguration.userinfo_endpoint)return null;const o=new BearerClient(t.access_token),n=await o.get(i.providerConfiguration.userinfo_endpoint).catch(()=>null);let s=[],a=null,d=null,l=null,p=!1;if(r.picture?l=r.picture:n&&n.picture&&(l=n.picture),r.email&&(a=r.email),a){const e=a.split("@");d=e[0],this.TrustedEmailDomains.indexOf(e[1].toLowerCase())>=0&&(p=r.email_verified)}return a&&p&&s.push({type:"email",value:a}),{uid:r.sub,provider:i.provider,providerProtocol:i.providerProtocol,providerId:i._id,providerData:n,userData:{},identities:s,username:d,domain:null,email:a,emailCertified:p,mobile:null,mobileCertified:!1,displayName:r.name,displayImageURL:l,familyName:r.family_name,givenName:r.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:r.locale}}})],ye.prototype,"google",void 0),ye=ie([a("/api/integration/google/auth")],ye);let he=class GitLabOpenIdAuthController extends OpenIdAuthController{async discover(e){if(!e.settings.OIDC_GITLAB)throw new Error("GitLabAuthIsNotEnabled");const t={provider:"gitlab",providerProtocol:"openid",providerURL:e.settings.OIDC_GITLAB_ISSUER_URL,displayName:"GitLab Account",displayImageURL:"https://about.gitlab.com/ico/favicon-192x192.png"},i=await this.idp.findOrResolveExternalProvider(e,t);return i.appID=i.appID||e.settings.OIDC_GITLAB_CLIENT_ID,i.appSecret=e.settings.OIDC_GITLAB_CLIENT_SECRET,e.settings.OIDC_GITLAB_SCOPES&&(i.scope=i.scope||e.settings.OIDC_GITLAB_SCOPES.join(" ")),i}async OnProfile(e,t,i){return this.gitlab.getProfile(e,t,i)}};ie([t(),re("design:type",ExternalProviderService)],he.prototype,"idp",void 0),ie([t(),re("design:type",class GitLabProfileService{async getProfile(e,t,i){const r=t.id_token;if(!i.providerConfiguration||!i.providerConfiguration.userinfo_endpoint)return null;const o=new BearerClient(t.access_token),n=await o.get(i.providerConfiguration.userinfo_endpoint);let s=[],a=n.picture;return n.email&&n.email_verified&&s.push({type:"email",value:n.email}),{uid:r.sub,provider:i.provider,providerProtocol:i.providerProtocol,providerURL:i.providerURL,providerId:i._id.toHexString(),providerData:n,userData:{},identities:s,username:n.nickname||null,domain:null,email:n.email||null,emailCertified:n.email_verified||!1,mobile:null,mobileCertified:!1,displayName:r.name||n.name,displayImageURL:a,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:null,homepage:n.profile||null,locale:null}}})],he.prototype,"gitlab",void 0),he=ie([a("/api/integration/gitlab/auth")],he);let me=class GitHubOpenIdAuthController extends OpenIdAuthController{async discover(e){if(!e.settings.OIDC_GITHUB)throw new Error("GitHubAuthIsNotEnabled");const t={provider:"github",providerProtocol:"oauth",providerURL:e.settings.OIDC_GITHUB_ISSUER_URL,displayName:"GitHub Account",displayImageURL:"https://github.com/favicon.ico",providerConfiguration:{issuer:e.settings.OIDC_GITHUB_ISSUER_URL,authorization_endpoint:"https://github.com/login/oauth/authorize",token_endpoint:"https://github.com/login/oauth/access_token",userinfo_endpoint:"https://api.github.com/user"}},i=await this.idp.findOrResolveExternalProvider(e,t);return i.appID=i.appID||e.settings.OIDC_GITHUB_CLIENT_ID,i.appSecret=i.appSecret||e.settings.OIDC_GITHUB_CLIENT_SECRET,e.settings.OIDC_GITHUB_SCOPES&&(i.scope=i.scope||e.settings.OIDC_GITHUB_SCOPES.join(" ")),i}async OnProfile(e,t,i){return this.github.getProfile(e,t,i)}};ie([t(),re("design:type",ExternalProviderService)],me.prototype,"idp",void 0),ie([t(),re("design:type",class GitHubProfileService{async getProfile(e,t,i){const r=new BearerClient(t.access_token),o=t.id_token;if(!i.providerConfiguration||!i.providerConfiguration.userinfo_endpoint)return null;const n=await r.get(i.providerConfiguration.userinfo_endpoint),s=await r.get("https://api.github.com/user/emails").then(e=>[]);let a=n.id,d=null,l=n.avatar_url,p=[];if(s&&s.length)for(const e of s)e.email&&e.primary&&e.verified&&(d=e.email,p.push({type:"email",value:e.email}));return{uid:a,provider:i.provider,providerProtocol:i.providerProtocol,providerURL:i.providerURL,providerId:i._id.toHexString(),providerData:n,userData:{},identities:p,username:n.login,domain:null,email:d,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:n.name||n.login,displayImageURL:l,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:n.bio||null,homepage:n.blog||n.html_url||null,locale:o.locale}}})],me.prototype,"github",void 0),me=ie([a("/api/integration/github/auth")],me);class MicrosoftGraphClient extends ExternalFetcher{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error("Access token can not be null or empty")}profile(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/me")}photo(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/me/photo").catch(e=>{const t=e.response.status;if(404===t||501===t)return null;throw new C(e,e.response.data,"Unable to resolve user photo")})}photoImage(e){return e?this.httpGetAsBuffer(`https://graph.microsoft.com/v1.0/me/photos/${e}/$value`):this.httpGetAsBuffer("https://graph.microsoft.com/v1.0/me/photo/$value")}photoImageDataURL(){return this.photo().then(e=>{if(!e)return Promise.resolve(null);const t=e["@odata.mediaContentType"],i=e.id;return this.photoImage(i).then(e=>`data:${t};charset=utf-8;base64,${e.toString("base64")}`)})}users(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/users")}}let fe=class FileModel extends P{};ie([x(),re("design:type",String)],fe.prototype,"type",void 0),ie([x(),re("design:type",Number)],fe.prototype,"byteLength",void 0),ie([x(),re("design:type",Buffer)],fe.prototype,"data",void 0),ie([x(),re("design:type",Number)],fe.prototype,"width",void 0),ie([x(),re("design:type",Number)],fe.prototype,"height",void 0),ie([x(),re("design:type",Number)],fe.prototype,"duration",void 0),ie([x(),re("design:type",String)],fe.prototype,"ipfs",void 0),fe=ie([T("file")],fe);class FileCollection extends D{constructor(){super(fe)}}let ve=class FileTokenModel extends P{};ie([x(),re("design:type",String)],ve.prototype,"file",void 0),ie([x(),re("design:type",String)],ve.prototype,"type",void 0),ie([x(),re("design:type",Number)],ve.prototype,"byteLength",void 0),ie([x(),re("design:type",String)],ve.prototype,"title",void 0),ie([x(),re("design:type",String)],ve.prototype,"originalname",void 0),ie([x(),re("design:type",String)],ve.prototype,"originalurl",void 0),ve=ie([T("file_token")],ve);class FileTokenCollection extends k{constructor(){super(ve)}}class WebFileService{async findTokenById(e,t){return(await e.resolve(FileTokenCollection)).get(t)}async findFileById(e,t){return(await e.resolve(FileCollection)).get(t)}async updateOne(e,t,i){return(await e.resolve(FileTokenCollection)).merge(t,{title:i.title})}async insertFromURL(e,t,i){const r=await function(e){return G(e).then(async e=>({data:await e.buffer(),dataType:e.headers.get("content-type")||"application/octet-stream",dataLength:parseInt(e.headers.get("content-length")||"0")}))}(t),o=t.split("/"),n=o[o.length-1];return this.insertFromBuffer(e,r.data,Object.assign({},i,{originalname:n,originalurl:t,type:r.dataType}))}async insertFromStream(e,t,i){const r=await d(t);return this.insertFromBuffer(e,r,i)}async insertFromBuffer(e,t,i){let{type:r}=i;const o=V("sha256").update(t).digest(),n=require("multihashes").encode(o,"sha2-256"),s=R.fromBuffer(n),a=await e.resolve(FileCollection),d=await e.resolve(FileTokenCollection),l=await a.get(s),p=(new O).toString();if(l){r=l.type;const e={file:s,type:l.type,byteLength:l.byteLength};i&&(e.title=i.title,e.originalname=i.originalname,e.originalurl=i.originalurl),await d.add(p,e)}else{const e={type:r=r||"application/octet-stream",byteLength:t.byteLength,data:t};if(i&&(e.width=i.width,e.height=i.height,e.duration=i.duration,e.ipfs=i.ipfs),!await a.add(s,e))throw new Error("UnableToSaveDataChunk");const o={file:s,type:r,byteLength:t.byteLength};i&&(o.title=i.title,o.originalname=i.originalname,o.originalurl=i.originalurl),await d.add(p,o)}return Object.assign({id:p,type:r,byteLength:t.byteLength,url:"/api/file/token/"+p},i)}}let Se,Ie=class MicrosoftOpenIdAuthController extends OpenIdAuthController{async discover(e){if(!e.settings.OIDC_MICROSOFT)throw new Error("MicrosoftAuthIsNotEnabled");const t={provider:"microsoft",providerProtocol:"openid",providerURL:e.settings.OIDC_MICROSOFT_ISSUER_URL,displayName:"Microsoft Account",displayImageURL:"https://www.microsoft.com/favicon.ico"},i=await this.idp.findOrResolveExternalProvider(e,t);return i.appID=i.appID||e.settings.OIDC_MICROSOFT_CLIENT_ID,i.appSecret=e.settings.OIDC_MICROSOFT_CLIENT_SECRET,e.settings.OIDC_MICROSOFT_SCOPES&&(i.scope=i.scope||e.settings.OIDC_MICROSOFT_SCOPES.join(" ")),i}async OnProfile(e,t,i){return this.profile.getProfile(e,t,i)}};ie([t(),re("design:type",ExternalProviderService)],Ie.prototype,"idp",void 0),ie([t(),re("design:type",class MicrosoftProfileService{constructor(){this.TrustedMicrosoftEmailDomains=["outlook.com","hotmail.com","live.cn","live.com","msn.com","passport.com","passport.net"]}async getProfile(e,t,i){const r=t.id_token;if(!i.providerConfiguration||!i.providerConfiguration.userinfo_endpoint)return null;const o=new MicrosoftGraphClient(t.access_token),n=await o.profile().catch(()=>null);let s=null;const a=await o.photo();if(a){const t=await o.photoImage(a.id);if(t){const i=await e.resolve(WebFileService),r=await i.insertFromBuffer(e,t,{type:a["@odata.mediaContentType"],width:a.width,height:a.height}).catch(e=>(console.log("err",e),console.log(`Unable to save profile image for microsoft user ${a.id}, displayImageURL will be NULL`),null));r&&r.url&&(s=r.url)}}let d=null,l=null,p=null,c=null,u=[],g=null,y=!1;if(n?(d=n.id,l=n.displayName):(d=r.oid||r.sub,l=r.name),r.preferred_username?p=r.preferred_username:n&&n.userPrincipalName&&(p=n.userPrincipalName),p){const e=p.split("@");2===e.length&&(c=e[1].toLowerCase())}if(r.email?g=r.email:n&&n.mail&&(g=n.mail),g){const t=g.split("@");if(2===t.length){this.TrustedMicrosoftEmailDomains.indexOf(t[1].toLowerCase())>=0&&(y=!0);for(const r of e.settings.TRUSTED_EMAIL_PROVIDERS||[])if(("microsoft"===r.provider||r.provider===i.providerURL)&&r.domains.indexOf(t[1].toLowerCase())>=0){y=!0;break}}}return g&&y&&u.push({type:"email",value:g}),{uid:d,provider:i.provider,providerProtocol:i.providerProtocol,providerURL:i.providerURL,providerId:i._id.toHexString(),providerData:n,userData:{},identities:u,username:p,domain:c,email:g,emailCertified:y,mobile:n&&n.mobilePhone,mobileCertified:!1,displayName:l,displayImageURL:s,familyName:n&&n.surname,givenName:n&&n.givenName,gender:null,dob:null,status:null,bio:n&&n.jobTitle,homepage:null,locale:n&&n.preferredLanguage}}})],Ie.prototype,"profile",void 0),Ie=ie([a("/api/integration/microsoft/auth")],Ie);class IdentityCookieHelper{static get(e){const t=e.cookies.getAll(e.settings.WEB_DEVICE_COOKIE_KEY);if(t)return t[t.length-1]}static set(e,t){const i=e.settings.WEB_DEVICE_COOKIE_DOMAIN||e.hostname,r=e.settings.WEB_DEVICE_COOKIE_KEY,o={path:"/",httpOnly:!0,maxAge:e.settings.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS,secure:!e.settings.DEBUG};if(Q(i))e.res.cookies.add(r,t,Object.assign({domain:i},o));else{const n=i.split(".");1===n.length&&e.res.cookies.add(r,t,Object.assign({domain:i},o)),n.length>1&&e.res.cookies.add(r,t,Object.assign({domain:n.slice(-2).join(".")},o)),n.length>2&&e.res.cookies.add(r,t,Object.assign({domain:n.slice(-3).join(".")},o))}return t}}class IdentityHelper{static getIdentityId(e){return this.verify(IdentityCookieHelper.get(e))}static createIdentityId(e){const t=this.sign(N.fromBuffer((new O).id));return e.state.new_device_id=t,e.logger.update({new_device:1}),IdentityCookieHelper.set(e,t)}static createIdentityAddress(e){const t=e.ip;let i=((t&&t.indexOf(":"))>=0?"/ip6/":"/ip4/")+t;const r=e.getHeader("x-forwarded-port");return r&&(i+="/tcp/"+r),i}static crc(e){let t=0;for(let i=0;i<e.length;i++)t+=e.charCodeAt(i);return N.singleton.alphabet[t%62]}static sign(e){return this.crc(e)+e}static verify(e){if(!e)return e;const t=e.slice(1),i=this.crc(t);return e[0]===i?t:void 0}}class WebFoundationRequestIdentity extends l{static[e](e,t){const i=new WebFoundationRequestIdentity;if(i.id=IdentityHelper.getIdentityId(e)||IdentityHelper.createIdentityId(e),i.address=IdentityHelper.createIdentityAddress(e),e.path.startsWith("/api")){const t={};SessionHelper.load(e,t),t&&t.session&&(U(new O(t.token))?SessionHelper.clear(e):Object.assign(i,t))}return i.theme=i.theme||e.settings.THEME,i.locale=i.locale||e.settings.LOCALE,i.timezone=i.timezone||e.settings.TIMEZONE,i}}class WebFoundationApplicationIdentity extends p{static[e](e){const t=new WebFoundationApplicationIdentity;return console.log("create app identity",e),t}}function _e(e,t){return t().then(t=>{null!=t&&e.logger.warn({result:t},"Return value from middleware is been ignored"),e.req.performance.log("router","[[End]]");const i=e.logger,r=`[${e.ip}] ${e.status} ${e.method} ${e.path}`,o={},n=Date.now()-e.req.timestamp.getTime()>e.settings.LOG_SLOW_REQUEST_IN_MILLISECONDS;if(e.verbose||n){n&&(o.slow=1),o.headers=function(e){const t=e.toJSON(),i={};for(const[e,r]of Object.entries(t))r.length&&(i[e]=r.length>1?r:r[0]);return i}(e.req.headers);try{o.identity=e.identity}catch(e){o.identity={__xXx__:e.message}}Object.keys(e.params).length&&(o.params=e.params),Object.keys(e.query).length&&(o.query=e.query)}let s,{total:a,header:d}=e.req.performance.build(e.settings.NAME);e.res.headers.set("x-response-time",a.toFixed(4)),e.res.headers.append("server-timing",d),s=a>1e3?0:a>100?1:a>10?2:3,o.t=a.toFixed(s);const l=e.error;l?(l instanceof C&&(l.code&&(o.code=l.code),l.context&&(o.context=l.context)),i.error(l,o,r)):e.state.silent?i.trace(o,r):i.info(o,r)})}function Ee(e,t){return t().then(t=>{const i=e.res;u(e),void 0===i.body&&(t instanceof Z||Buffer.isBuffer(t)?i.body=t:i.body=function(e){return Array.isArray(e)?{ok:1,results:e}:void 0!==e?{ok:1,result:e}:{ok:1}}(t)),void 0===i.status&&(i.status=200)}).catch(t=>{u(e),e.error=t;const{statusCode:i,statusMessage:r,headers:o,body:n}=function(e,t){let i,r,o=500,n="Server Exception";return t instanceof Error?t instanceof C?(t instanceof c&&(t.headers&&(i=t.headers),t.statusCode&&(o=t.statusCode),t.statusMessage&&(n=t.statusMessage)),r=Object.assign({},t.toJSON(),{ok:0})):r={ok:0,error:t.name,message:t.message,stack:t.stack}:r={ok:0},{statusCode:o,statusMessage:n,headers:i,body:r}}(0,t);o&&e.res.setHeaders(o),null!=n&&(e.res.body=n),e.res.statusCode=i,e.res.statusMessage=r})}function we(e,t){const i=`REQ/${e.identity.id}/${e.req.timestamp.getTime()}`;e.req.logger.update({req_id:i}),e.setHeader("x-request-id",i),e.setHeader("x-request-count",String(e.req.id)),e.performance.log("router","[[LookupRoute]]");const r=e.req.app.router.search(e.method,e.path);return r&&(e.req.params=r.params,r.handler&&"function"==typeof r.handler)?r.handler(e):t()}function be(e,t){return"GET"===e.method?(e.status=404,e.body={ok:0,message:"Route Not Found"}):(e.status=405,e.body={ok:0,message:"Method Not Allowed"}),t()}const Oe=new RegExp(/^text\/html/);function Ce(e,t,i={}){const r=q($(i.root||e.settings.PUBLIC_DIR)),o="/"===(t=t||"/")[t.length-1];t=t.substr(J(t).root.length);const n=i.index||"index.html",s=i.maxAge||e.settings.PUBLIC_DIR_CACHE_EXPIRES_IN_SECONDS;t=function(e){try{return decodeURIComponent(e)}catch(e){throw new C(e,"failed to decode")}}(t),o&&(t+=n);const a=function(e,t){if(-1!==t.indexOf("\0"))throw new g("NULL is not allowed in request path");if(Se||(Se=/(?:^|[\\\/])\.\.(?:[\\\/]|$)/),Se.test(q("."+z+t)))throw new g("Up path (../) is not allowed in request path");if(K(t))throw new g("Absolute path is not allowed");return q(H($(e),t))}(r,t);if(function(e,t){const i=t.substr(e.length).split(z);if(".well-known"===i[0])return!1;for(let e=0;e<i.length;e++)if("."===i[e][0])return!0;return!1}(r,a))return!1;let d;try{if((d=ee(a)).isDirectory())return!1}catch(e){if(~["ENOENT","ENAMETOOLONG","ENOTDIR"].indexOf(e.code))return!1;throw new y(e,"Unable to access requested file")}e.logger.update({sz:(d.size/1024).toFixed(1)});const l=e.res;var p,c;return l.lastModified||(l.lastModified=d.mtime),l.status=200,l.length=d.size,l.type=(p=a,"."===(c=X(""!==(c="")?Y(p,c):p))[0]?c.slice(1):c),l.hasHeader("x-content-type-options")||l.setHeader("x-content-type-options","nosniff"),s>0?l.hasHeader("cache-control")||l.setHeader("cache-control","public, max-age="+s):(l.hasHeader("pragma")||l.setHeader("pragma","no-cache"),l.hasHeader("cache-control")||l.setHeader("cache-control","no-cache, no-store, must-revalidate")),l.type.match(Oe)&&(e.settings.DEBUG||l.setHeader("strict-transport-security","max-age=31536000; includeSubDomains"),Array.isArray(e.settings.WEB_CONTENT_SECURITY_POLICY)&&l.setHeader("content-security-policy",e.settings.WEB_CONTENT_SECURITY_POLICY.join(" ")),l.setHeader("x-frame-options","SAMEORIGIN"),l.setHeader("x-xss-protection","1")),l.body=te(a),e.state.silent=!0,{file:a,type:l.type,length:d.size}}function Ne(e,t){if("GET"===e.method){e.performance.log("router","[[ServeStaticFile]]");try{Ce(e,e.path)||(e.status=404,e.body={ok:0,message:"File Not Found"})}catch(t){e.logger.error(t,"send file")}}else e.status=405,e.body={ok:0,message:"Method Not Allowed"};return t()}class MultipartWebForm extends f{static[e](e,t){const i=new MultipartWebForm,r=e.type;if("multipart/form-data"===r){const t=String(e.headers.get("content-type"));if(Buffer.isBuffer(e.body)||"string"==typeof e.body)return function(e,t,i){return new Promise((r,o)=>{const n=new(require("busboy"))({headers:{"content-type":e}});n.on("file",(e,t,r,o,n)=>{const s=new h;s.name=e,s.originalname=r,s.mimetype=n,s.encoding=o;const a=[];t.on("data",e=>{a.push(e)}),t.on("end",()=>{s.data=Buffer.concat(a),i.push(s)})}),n.on("field",(e,t)=>{const r=new m;r.name=e,r.value=t,i.push(r)}),n.on("error",e=>o(new C(e,"Error parse form buffer"))),n.on("finish",()=>r(i)),n.write(t),n.end()})}(t,e.body,i);if(e.body instanceof Z)return function(e,t,i){return new Promise((r,o)=>{const n=new(require("busboy"))({headers:{"content-type":e}});n.on("file",(e,t,r,o,n)=>{const s=new h;s.name=e,s.originalname=r,s.mimetype=n,s.encoding=o;const a=[];t.on("data",e=>{a.push(e)}),t.on("end",()=>{s.data=Buffer.concat(a),i.push(s)})}),n.on("field",(e,t)=>{const r=new m;r.name=e,r.value=t,i.push(r)}),n.on("error",e=>o(new C(e,"Error parse form buffer"))),n.on("finish",()=>r(i)),t.pipe(n)})}(t,e.body,i);throw new Error("Unknown body type for form: "+typeof e.body)}if("application/x-www-form-urlencoded"===r)return e.text().then(e=>{const t=B(e),i=new f;return Object.keys(t).map(e=>{const r=new m;return r.name=e,r.value=String(t[e]),i.push(r),r}),i});throw new Error(`Content-Type: ${e.type} is not a form`)}}class WebFoundationApplication extends v{invoke(e){return this.middleware.compose(e)}onInit(){this.addType(WebFoundationRequestIdentity),this.addType(WebFoundationApplicationIdentity),this.addType(MultipartWebForm),this.addMiddleware(_e),this.addMiddleware(Ee),this.addMiddleware(we),this.onInitApplication(),this.settings.PUBLIC_DIR?(this.logger.warn(`Serving files from ${this.settings.PUBLIC_DIR}`),this.addMiddleware(Ne)):this.addMiddleware(be)}}class WebFoundationSettings extends S{constructor(){super(...arguments),this.PUBLIC_DIR_CACHE_EXPIRES_IN_SECONDS=600,this.LOG_SLOW_REQUEST_IN_MILLISECONDS=1e4,this.WEB_DEVICE_COOKIE_KEY="__xXx__",this.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS=3456e4,this.WEB_SESSION_COOKIE_KEY="__xXx__",this.WEB_SESSION_COOKIE_EXPIRES_IN_SECONDS=1800,this.WEB_SESSION_EXPIRES_IN_MILLISECONDS=18e5,this.WEB_CONTENT_SECURITY_POLICY=["script-src","'self'"],this.WEB_TOKEN_EXPIRES_IN_MILLISECONDS=3e5,this.WEB_SIGNIN_PATH="/authentication/signin",this.WEB_SIGNIN_SUCCESS_PATH="/authentication/validate",this.WEB_SIGNIN_FAILED_PATH="/authentication/failed",this.WEB_ACCESS_DENIED_PATH="/authentication/access_denied",this.WEB_SIGNOUT_PATH="/authentication/signout",this.WEB_SIGNOUT_COMPLETE_PATH="/",this.TRUSTED_EMAIL_PROVIDERS=[],this.THEME="default",this.OWNER_COMPANY_ADDRESS=[],this.OWNER_AGREEMENTS=[]}}class BotService extends WebFoundationService{dispatch(e,t){console.log("dispatch",t)}}class Random{static generateRandomNumber(e){const t=Math.pow(10,e-1),i=Math.pow(10,e);return Math.floor(Math.random()*(i-t)+t)}static generateRandomToken(e){const t=[],i=this.POOL,r=this.MAX;for(let o=0;o<e;o++){const e=Math.floor(Math.random()*r);t.push(i[e])}return t.join("")}}Random.POOL="2346789BbCcDdFfGgHhJjKkMmPpQqRrTtVvWwXxYy",Random.MAX=Random.POOL.length;class MessageIdentity extends WebFoundationRequestIdentity{}class TelegramMessageIdentity extends MessageIdentity{static[e](e,[t]){let i=`${t.first_name}`;t.last_name&&(i+=` ${t.last_name}`);const r={uid:t.id,providerId:"3fdeba596a7d938a05c38daf"},o=b(r).toHexString(),n=new TelegramMessageIdentity;return n.id=t.id,n.address=IdentityHelper.createIdentityAddress(e)+"/tg/"+t.id,n.user=o,n.profile={_id:o,id:t.username,displayName:i,displayImageURL:""},t.is_bot&&(n.profile.bot=t.is_bot),n.theme=n.theme||e.settings.THEME,n.locale=t.language_code||e.settings.LOCALE,n.timezone=n.timezone||e.settings.TIMEZONE,n}}let Ue=class TelegramBotController extends WebFoundationController{async telegram(e){if(!e.params.token)throw new n("Missing bot token for telegram");if(e.settings.TELEGRAM_BOT_TOKEN!=e.params.token)throw new n("Invalid bot token");const t=await e.json(),i=t.channelData||t,r=await e.resolve(TelegramMessageIdentity,function(e){const t=e.message||e.callback_query||e.edited_message||e.pre_checkout_query;let i;if(t)i=t.from;else{const t=Object.keys(e),r=t.find(t=>!!e[t].from);if(!r)throw new n(`Unable to find 'from' field in message: ${t}`);i=e[r].from}return[i,t,e]}(i));let o,s,a,d;if(i.message)s=(o=i.message).chat,d=o.text,a=new Date(1e3*o.date);else if(i.callback_query)s=(o=i.callback_query.message).chat,d=i.callback_query.data,a=new Date(1e3*o.date);else{if(!i.pre_checkout_query)return i.edited_message?(this.logger.debug({sourceEvent:i},"Edit message is ignored in this version"),void(e.body=null)):(this.logger.error({sourceEvent:i},"Unknown message type"),void(e.body=null));{const e=i.pre_checkout_query.from;s={id:e.id,first_name:e.first_name,last_name:e.last_name,username:e.username,type:"private"},d=i.pre_checkout_query.invoice_payload,a=new Date}}const l={id:Random.generateRandomToken(10),type:"message",identity:r,timestamp:a,from:{id:r.id,name:r.profile.displayName},conversation:{isGroup:"private"!==s.type,id:s.id},recipient:{id:e.settings.TELEGRAM_BOT_ID,name:e.settings.NAME},channelId:"telegram",channelData:i,text:d};this.bot.dispatch(e,l)}};ie([t(),re("design:type",BotService)],Ue.prototype,"bot",void 0),ie([r("POST","/update/:token"),re("design:type",Function),re("design:paramtypes",[Object]),re("design:returntype",Promise)],Ue.prototype,"telegram",null),Ue=ie([a("/api/integration/telegram/bot")],Ue);let Le=class WebFileController{async token(e){const t=await this.WebFile.findTokenById(e,e.params.id);if(!t)throw new I;const i=R.fromBuffer(b(t.file).id),r=e.headers.get("if-none-match");if(r&&r===i)e.body=null,e.status=304;else{const r=await this.WebFile.findFileById(e,t.file);if(!r)throw new I;e.body=r.data,e.setHeader("etag",i),e.setHeader("content-type",r.type),e.setHeader("content-length",`${r.byteLength}`),e.status=200}}};ie([t(),re("design:type",WebFileService)],Le.prototype,"WebFile",void 0),ie([r("GET","/token/:id"),re("design:type",Function),re("design:paramtypes",[Object]),re("design:returntype",Promise)],Le.prototype,"token",null),Le=ie([a("/api/file")],Le);export{BotService,ExternalFetcher,ExternalProviderService,ExternalUserService,me as GitHubOpenIdAuthController,he as GitLabOpenIdAuthController,ye as GoogleOpenIdAuthController,Ie as MicrosoftOpenIdAuthController,MultipartWebForm,_e as RequestLogMiddleware,Ee as RequestNormalizerMiddleware,be as RequestNotFoundMiddleware,we as RequestRouteMiddleware,Ne as RequestStaticMiddleware,SessionService,Ue as TelegramBotController,Le as WebFileController,WebFileService,WebFoundationApplication,WebFoundationApplicationIdentity,WebFoundationRequestIdentity,WebFoundationSettings};
//# sourceMappingURL=index.mjs.map
